Subject: Re: vlan missing with AF_PACKET and auxdata

From: Jan Grashöfer <[email-masked]>
Date: Mon, 24 Sep 2018 14:22:17 +0200

Hi Michael,

On 24/09/2018 14:01, Michael Walle wrote:
> I'm using the AF_PACKET socket with setsockopt(PACKET_AUXDATA) to get 
> the incoming VLAN tag. Correct me if I'm wrong, but as far as I see the 
> first VLAN tag is always stripped - either in hardware or in 
> net/core/dev.c in __netif_receive_skb_core() - and stored in 
> skb->vlan_tci. Therefore, it won't be in the packet data anymore.

although the documentation says "SOCK_RAW packets are passed to and from 
the device driver without any changes in the packet data." [1] that's 
correct and was discussed here: 
https://www.spinics.net/lists/netdev/msg440313.html

Result of the discussion: Won't fix, too complicated.

Jan

[1] http://man7.org/linux/man-pages/man7/packet.7.html